<?php
namespace Teqpay\TeqpayPos\Controller\Sanalpos;

class Installment extends \Magento\Framework\App\Action\Action
{
	protected $_pageFactory;
	protected $_checkoutSession;
	protected $_storeManager;
	protected $_scopeConfig;

	public function __construct(
		\Magento\Framework\App\Action\Context $context,
		\Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Framework\View\Result\PageFactory $pageFactory)
	{
		$this->_pageFactory = $pageFactory;
		$this->_checkoutSession = $checkoutSession;
		$this->_scopeConfig = $scopeConfig;
		$this->_storeManager = $storeManager;
		return parent::__construct($context);
	}

	public function execute()
	{
        $page = $this->_pageFactory->create();

    //We are using HTTP headers to control various page caches (varnish, fastly, built-in php cache)
        $page->setHeader('Cache-Control', 'no-store, no-cache, must-revalidate, max-age=0', true);


        $sandbox = $this->_scopeConfig->getValue('payment/teqpay_pos/sandbox'); 
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance(); 
        $cartObj = $objectManager->get('\Magento\Checkout\Model\Cart');
		$grandTotal = $cartObj->getQuote()->getGrandTotal();

        
		$url = $sandbox == 1 ? 'https://merchant-test.teqpay.com/api/teqpay/installmentinfo' : 'https://merchant.teqpay.com/api/teqpay/installmentinfo';

       
        $json = [
            'cardNo' => substr($_GET['card'], 0, 6),
            'price' => number_format($grandTotal, 2, '.', ''),
            'language' => 'TR'
        ];


        $response = $this->curl($url, 'POST', json_encode($json));

        $option = '';
        if($response['Result'] == 1){
            foreach ($response['Details'] as $key => $i) {

                if ($key == 0) {
                    $option .= "<option value='1'>Tek Çekim (" . $i['AmountToPaid'] . ")</option>";
                } else {
                    $option .= "<option value='" . $i['Installment'] . "'>" . $i['Installment'] . " Taksit (" . $i['AmountToPaid'] . ")</option>";
                }
            }
        } else {
            $option .= $option .= "<option value='1'>Tek Çekim</option>";
        }
        

        echo $option;

	}


    private function curl($url, $method, $json)
    {
        $secret_key = $this->_scopeConfig->getValue('payment/teqpay_pos/apisecret');
        $api_key = $this->_scopeConfig->getValue('payment/teqpay_pos/apikey');

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_VERBOSE => true,
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $method,
            CURLOPT_POSTFIELDS => $json,
            CURLOPT_HTTPHEADER => [
              "Content-Type: application/json",
              "ApiKey: {$api_key}",
              "SecretKey: {$secret_key}",
            ]
        ]);

        $response = curl_exec($curl);
		$response = json_decode($response, true);
        curl_close($curl);

        return $response;
    }

    
}