<?php
namespace Teqpay\TeqpayPos\Controller\Sanalpos;

use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\App\CsrfAwareActionInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\Request\InvalidRequestException;
use Magento\Quote\Model\QuoteIdToMaskedQuoteIdInterface;

class Request extends \Magento\Framework\App\Action\Action implements CsrfAwareActionInterface
{
    protected $_context;
    protected $_pageFactory;
    protected $_jsonEncoder;
    protected $_checkoutSession;
    protected $_customerSession;
    protected $_scopeConfig;
	protected $_storeManager;
	protected $_redirect;
	protected $_coreSession;
	protected $_messageManager;
	protected $_cartManagement;
    protected $_quoteIdToMaskedQuoteId;
    protected $_guestCartManagement;

    

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\Json\EncoderInterface $encoder,
        \Magento\Framework\View\Result\PageFactory $pageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Customer\Model\Session $customerSession,
        \Magento\Quote\Api\CartManagementInterface $cartManagement,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\Session\SessionManagerInterface $coreSession, 
		\Magento\Framework\App\Response\RedirectInterface $redirect,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Checkout\Api\GuestPaymentInformationManagementInterface $guestCartManagement,
		\Magento\Store\Model\StoreManagerInterface $storeManager,
        QuoteIdToMaskedQuoteIdInterface $quoteIdToMaskedQuoteId
        
    ) {
        $this->_context = $context;
        $this->_pageFactory = $pageFactory;
		$this->_jsonEncoder = $encoder;
        $this->_checkoutSession = $checkoutSession;
        $this->_customerSession = $customerSession;
        $this->_scopeConfig = $scopeConfig;
        parent::__construct($context);
        $this->_resultRedirect = $context->getResultFactory();
        $this->_storeManager = $storeManager;
        $this->_messageManager = $messageManager;
        $this->_redirect = $redirect;
        $this->_coreSession = $coreSession;
        $this->_cartManagement = $cartManagement;
        $this->_guestCartManagement = $guestCartManagement;
        $this->_quoteIdToMaskedQuoteId = $quoteIdToMaskedQuoteId;
        $this->checkAndSetCookieSameSite();
    }

    public function execute()
    {
        
		$checkoutSession = $this->_checkoutSession->getQuote();

        $resultRedirect = $this->_resultRedirect->create(ResultFactory::TYPE_REDIRECT);
        $currency = $this->_storeManager->getStore()->getCurrentCurrency()->getCode();


        $card_information = $this->_coreSession->getCard();

  			$billingAddress  = $checkoutSession->getBillingAddress();
			$shippingAddress  = $checkoutSession->getBillingAddress();

            $sandbox = $this->_scopeConfig->getValue('payment/teqpay_pos/sandbox'); 
	


        $shipping_cost = $this->_checkoutSession
            ->getQuote()
            ->getShippingAddress()
            ->getShippingAmount();

       
        $cart_items = $this->_checkoutSession->getQuote()->getAllItems();
        $count = 0;
        foreach ($cart_items as $item) {
            $count += (int) $item->getQty();
        }
 

        $items = [];

        foreach ($cart_items as $item) {
            $items[] = [
				'merchantItemId' => $item->getId(),
				'itemType' => 'Ürün',
				'itemCategory' => 'Ürün',
                'itemName' => $item->getName(),
                'itemPrice' => $item->getPrice(),
                'itemQuantity' => (int) $item->getQty(),
            ];
        }

        if($shipping_cost > 0){
            $items[] = [
               'merchantItemId' => "1000000000000",
               'itemType' => 'Kargo',
               'itemCategory' => 'Kargo',
               'itemName' => 'Kargo',
               'itemPrice' => $shipping_cost,
               'itemQuantity' => 1,
           ];
          }

        $grand_total = $this->_checkoutSession->getQuote()->getGrandTotal();
        $currency = $this->_storeManager->getStore()->getCurrentCurrency()->getCode();
        $order_id = $checkoutSession->getId();
        
        $billing_name = $billingAddress->getFirstname() . ' ' . $billingAddress->getLastname();
		$shipping_name = $shippingAddress->getFirstname() . ' ' . $shippingAddress->getLastname();

		$billing = [
			"billingName" => $billing_name,
            "billingCity" => $billingAddress->getCity() ?? 'Girilmedi',
            "billingCountry" => 'Türkiye',
            "billingAddress" => $billingAddress->getStreet()[0] ?? 'Girilmedi',
		];

		$shipping = [
			"shippingContactName" => $shipping_name,
            "shippingCity" => $shippingAddress->getCity() ?? 'Girilmedi',
            "shippingCountry" => 'Türkiye',
            "shippingAddress" => $shippingAddress->getStreet()[0] ?? 'Girilmedi',
		];
        $grand_total = $this->_checkoutSession->getQuote()->getGrandTotal();
        $currency = $this->_storeManager->getStore()->getCurrentCurrency()->getCode();
        $order_id = $checkoutSession->getId();

        $data = [

			// Customer
            'customerName' => $billing_name ?? '',
            'customerIpAddress' => $this->ip(),
            'customerCitizenNo' => 12345678901,
            'customerEmail' => $billingAddress->getEmail(),
            'customerPhone' => $billingAddress->getTelephone(),
            'language' => 'TR',
			// Order
            'price' => number_format(abs($grand_total), 2, ".", ""),
			'currency' => $currency,
			'conversationId' => $order_id . 'MAGENTO' . md5(microtime()),

			// Products
			'products' => $items,

			// Billign
			'billing' => $billing,

			// Shipping
			'shipping' => $shipping,

            'callbackUrl' => $this->_storeManager->getStore()->getBaseUrl() . 'teqpay/sanalpos/response',
            
        ];

        // Credit Card
        $card_data = [];
        if(isset($card_information['payment']['common']) && $card_information['payment']['common'] == '1')
        {
            $card_data['cardData'] = [
                "cardNo" => $card_information['payment']['cc_number'],
                "cardHolderName" => $card_information['payment']['cc_holder'],
                "expDate" => $card_information['payment']['cc_exp_month'] . '/' . substr ($card_information['payment']['cc_exp_year'], -2),
                "cvv" => $card_information['payment']['cc_cid'], 
                "installment" => $card_information['payment']['cc_installments'],
                "isPreAuth" => "false"
            ];

            $data['paymentMethodId'] = "1";
            $data['moneyTransferData'] = [
                'ibanNo' => null,
                'moneyTransferCode' => null

            ];
        }

		$json = (array_merge($data, $card_data));


        $sandbox = $this->_scopeConfig->getValue('payment/teqpay_pos/sandbox'); 
        $url = $sandbox == 1 ? 'https://merchant-test.teqpay.com/api/teqpay/paywithcommonpage' : 'https://merchant.teqpay.com/api/teqpay/paywithcommonpage';
        if(isset($json['cardData'])){
            $url = $sandbox == 1 ? 'https://merchant-test.teqpay.com/api/teqpay/payment' : 'https://merchant.teqpay.com/api/teqpay/payment';
        }


        $response = $this->curl($url, 'POST', json_encode($json));

  
        if($response['Result'] == true){
            echo ("<script>location.href='" . $response['PaymentData']['PaymentUrl'] . "'</script>");
            exit;
        } else {
            $this->_messageManager->addErrorMessage($response['ResultMessage']);
            $resultRedirect->setPath('checkout/cart', ['_secure' => true]);
            return $resultRedirect;
        }



    }

    private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly) {

        if (PHP_VERSION_ID < 70300) {

            setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
        }
        else {
            setcookie($name, $value, [
                'expires' => $expire,
                'path' => $path,
                'domain' => $domain,
                'samesite' => 'None',
                'secure' => $secure,
                'httponly' => $httponly
            ]);


        }
    }

    private function checkAndSetCookieSameSite(){



        foreach ($_COOKIE as $cookieName => $value) {
  
                    $this->setcookieSameSite($cookieName,$_COOKIE[$cookieName], time() + 86400, "/", $_SERVER['SERVER_NAME'],true, true);
 
        }
    }

    

    private function ip()
	{
		$ip = '';
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}

		return $ip;
	}

    private function curl($url, $method, $json)
    {
        $secret_key = $this->_scopeConfig->getValue('payment/teqpay_pos/apisecret');
        $api_key = $this->_scopeConfig->getValue('payment/teqpay_pos/apikey');

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_VERBOSE => true,
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $method,
            CURLOPT_POSTFIELDS => $json,
            CURLOPT_HTTPHEADER => [
              "Content-Type: application/json",
              "ApiKey: {$api_key}",
              "SecretKey: {$secret_key}",
            ]
        ]);

        $response = curl_exec($curl);
		$response = json_decode($response, true);
        curl_close($curl);

        return $response;
    }

    public function createCsrfValidationException(RequestInterface $request): ? InvalidRequestException
    {
        return null;
    }
        
    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }

    public function orders($result)
    {   

        $resultRedirect = $this->_resultRedirect->create(ResultFactory::TYPE_REDIRECT);
        $checkoutSession = $this->_checkoutSession->getQuote();

        $payment_type = $checkoutSession->getPayment()->setMethod('teqpay_pos');

        $this->_quote = $this->_checkoutSession->getQuote();
        $customerId = 0;
        $billingAddress  = $checkoutSession->getBillingAddress();

        if($billingAddress->getEmail()){

            $email = $billingAddress->getEmail();
        
        } else {
  
            $email = $this->_customerSession->getCustomer()->getEmail();
        }


        if($this->_customerSession->isLoggedIn()){
            $customerId = $this->_customerSession->getCustomerId();
        }
        $data = $this->getRequest()->getParams();

        if($result->status_code == 100){
            if($this->_customerSession->isLoggedIn()) {
                /* Place Order - Login Checkout */
                $this->_cartManagement->placeOrder($checkoutSession->getId());
  

            } else {
                $quoteId = $this->getQuoteMaskId($checkoutSession->getId());
                try {
                    $this->_guestCartManagement->savePaymentInformationAndPlaceOrder($quoteId,$email,$payment_type,$this->_checkoutSession->getBillingAddress());

                } catch(\Exception $e){
                    echo $e->getMessage(); exit;
                }
                

            }
        } else {
            $this->_messageManager->addErrorMessage($data['error']);
            $resultRedirect->setPath('checkout/cart', ['_secure' => true]);
            return $resultRedirect;
        }


            
        $resultRedirect->setPath('checkout/onepage/success', ['_secure' => true]);
        return $resultRedirect;

    }

    private function getQuoteMaskId($quoteId)
    {
        $maskedId = null;
        try {
            $maskedId = $this->_quoteIdToMaskedQuoteId->execute($quoteId);
        } catch (NoSuchEntityException $exception) {
            throw new LocalizedException(__('Current user does not have an active cart.'));
        }

        return $maskedId;
    }
}
